﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;


namespace ccc4
{


    // **********************
    // http://memeplex.blog.shinobi.jp/Entry/55/
    // かんたんXNA　その３０　カスタム頂点 より
    public struct VertexPositionNormalColor
    {
        public Vector3 Position;
        public Vector3 Normal;
        public Color Color;



        public VertexPositionNormalColor(Vector3 position, Vector3 normal, Color color)
        {
            this.Position = position;
            this.Normal = normal;
            this.Color = color;
        }

        public static readonly VertexElement[] VertexElements = {
            // Position
            new VertexElement(
                0,
                0,
                VertexElementFormat.Vector3,
                VertexElementMethod.Default,
                VertexElementUsage.Position,
                0
            ),

            // Normal
            new VertexElement(
                0, 
                sizeof(float) * 3,
                VertexElementFormat.Vector3,
                VertexElementMethod.Default,
                VertexElementUsage.Normal,
                0
            ),

            // Color
            new VertexElement(
                0,
                sizeof(float)*(3 + 3),
                VertexElementFormat.Color,
                VertexElementMethod.Default,
                VertexElementUsage.Color,
                0
            )
        };

        // 頂点バッファを使うのなら、頂点のサイズを表すメンバが必要
        public static readonly int Size = sizeof(float) * (3 + 3) + sizeof(byte) * 4;
        // sizeof(float) * (3 + 3) : 頂点+法線
        // sizeof(byte) * 4 : Color rgba

    }

    // **********************

    public struct Face
    {
        public int A, B, C;

        public void Set(int a, int b, int c)
        {
			/*
			this.A = a;
            this.B = b;
            this.C = c;
			*/
			
			// CullMode.CullClockwiseFace とするために順序変更
			this.A = a;
			this.B = c;
			this.C = b;

        }
    }


}
